package fi.cgi.bis.soa.example;

import java.util.Properties;

import javax.naming.Context;

import org.apache.camel.CamelContext;
import org.apache.camel.impl.DefaultCamelContext;
import org.apache.camel.impl.JndiRegistry;
import org.jboss.soa.esb.actions.AbstractActionLifecycle;
import org.jboss.soa.esb.addressing.eprs.JMSEpr;
import org.jboss.soa.esb.common.Configuration;
import org.jboss.soa.esb.helpers.ConfigTree;
import org.jboss.soa.esb.helpers.NamingContextPool;
import org.jboss.soa.esb.message.Message;
import org.jboss.soa.esb.util.JndiUtil;

public class MyCamelAction extends AbstractActionLifecycle {

    protected ConfigTree _config;

    private Context jndiContext = null;
    private CamelContext camelContext = null;
    private Properties jndiEnvironment = null;

    public MyCamelAction(ConfigTree config) {
        _config = config;
        try {
            jndiEnvironment = JndiUtil.parseEnvironmentProperties(_config);
            jndiEnvironment.setProperty(Context.PROVIDER_URL, _config.getAttribute(JMSEpr.JNDI_URL_TAG, Configuration.getJndiServerURL()));
            jndiEnvironment.setProperty(Context.INITIAL_CONTEXT_FACTORY, _config.getAttribute(JMSEpr.JNDI_CONTEXT_FACTORY_TAG, Configuration.getJndiServerContextFactory()));
            jndiEnvironment.setProperty(Context.URL_PKG_PREFIXES, _config.getAttribute(JMSEpr.JNDI_PKG_PREFIX_TAG, Configuration.getJndiServerPkgPrefix()));

            jndiContext = NamingContextPool.getNamingContext(jndiEnvironment);

            camelContext = new DefaultCamelContext(new JndiRegistry(jndiContext));
            camelContext.start();

        } catch (Exception ex) {
            ex.printStackTrace();
        }        
    }

    public Message process(Message message) throws Exception {

        return message;
    }
}
